# AEUS 介绍

`AEUS` 是一个轻量级的golang脚手架框架，用于快速开发微服务。



# 环境变量

| 环境变量 | 描述 |
| --- | --- |
| AEUS_DEBUG | 是否开启debug模式 |
| HTTP_PORT | http服务端口 |
| GRPC_PORT | grpc服务端口 |
| CLI_PORT | cli服务端口 |


# 快速开始

## 创建一个项目

创建项目可以使用`aeus`命令行工具进行生成:

```
aeus new github.com/your-username/your-project-name
```

如果需要创建一个带管理后台的应用, 可以使用`--admin`参数:

```
aeus new github.com/your-username/your-project-name --admin
```


## 生成`Proto`文件

服务使用`proto3`作为通信协议，因此需要生成`Proto`文件。

```
make proto
```

清理生成的文件使用:

```
make proto-clean
```

## 编译项目

编译项目可以使用`make`命令进行编译:

```
make build
```


# 目录结构

```
├── api
│   └── v1
├── cmd
│   ├── main.go
├── config
│   ├── config.go
│   └── config.yaml
├── deploy
│   └── docker
├── go.mod
├── go.sum
├── internal
│   ├── models
│   ├── scope
│   ├── service
├── Makefile
├── README.md
├── third_party
│   ├── aeus
│   ├── errors
│   ├── google
│   ├── openapi
│   ├── README.md
│   └── validate
├── vendor
├── version
│   └── version.go
├── web
└── webhook.yaml
```

| 目录 | 描述 |
| --- | --- |
| api | api定义目录 |
| cmd | 启动命令目录 |
| config | 配置目录 |
| deploy | 部署目录 |
| internal | 内部文件目录 |
| internal.service | 服务定义目录 |
| internal.models | 模型定义目录 |
| internal.scope | 服务scope定义目录,主要有全局的变量(比如DB,Redis等) |
| third_party | 第三方proto文件目录 |
| web | 前端资源目录 |