package errors

const (
	OK                 = 0    //success
	Exit               = 1000 //normal exit
	Invalid            = 1001 //payload invalid
	Exists             = 1002 //already exists
	Unavailable        = 1003 //service unavailable
	Incompatible       = 1004 //type incompatible
	Timeout            = 2001 //timeout
	Expired            = 2002 //expired
	TokenExpired       = 4002 //token expired
	NotFound           = 4004 //not found
	PermissionDenied   = 4003 //permission denied
	AccessDenied       = 4005 //access denied
	NetworkUnreachable = 5001 //network unreachable
	ConnectionRefused  = 5002 //connection refused
)

var (
	ErrExit               = New(Exit, "normal exit")
	ErrTimeout            = New(Timeout, "timeout")
	ErrExists             = New(Exists, "already exists")
	ErrExpired            = New(Expired, "expired")
	ErrInvalid            = New(Invalid, "invalid payload")
	ErrNotFound           = New(NotFound, "not found")
	ErrAccessDenied       = New(AccessDenied, "access denied")
	ErrPermissionDenied   = New(PermissionDenied, "permission denied")
	ErrTokenExpired       = New(TokenExpired, "token expired")
	ErrUnavailable        = New(Unavailable, "service unavailable")
	ErrNetworkUnreachable = New(NetworkUnreachable, "network unreachable")
	ErrConnectionRefused  = New(ConnectionRefused, "connection refused")
	ErrIncompatible       = New(Incompatible, "incompatible")
)
