package resolver

import (
	"context"

	"git.nobla.cn/golang/aeus/registry"
)

type (
	options struct {
		context  context.Context
		registry registry.Registry
	}

	Option func(*options)
)

func WithContext(ctx context.Context) Option {
	return func(o *options) {
		o.context = ctx
	}
}

func WithRegistry(registry registry.Registry) Option {
	return func(o *options) {
		o.registry = registry
	}
}

func newOptions(cbs ...Option) *options {
	opts := &options{
		context: context.Background(),
	}
	for _, cb := range cbs {
		cb(opts)
	}
	return opts
}
